KINFO_GETFILE(3)

NAME
kinfo_getfile - function for getting per-process file descriptor information

LIBRARY
libutil

SYNOPSIS
#include <sys/types.h>
#include <sys/user.h>
#include <libutil.h>
struct kinfo_file *
kinfo_getfile(pid_t pid, int *cntp);

DESCRIPTION
This function is used for obtaining the file descriptor information of a particular process.

The pid field contains the process identifier. This should be the a process that you have privilege to access. The cntp field allows the caller to know how many records are returned.

This function is a wrapper around sysctl(3) with the KERN_PROC_FILEDESC mib. While the kernel returns a packed structure, this function expands the data into a fixed record format.

RETURN VALUES
On success the kinfo_getfile() function returns a pointer to an array of struct kinfo_file structures as defined by <sys/user.h>. The array was obtained by an internal call to malloc(3) and must be freed by the caller with a call to free(3). On failure the kinfo_getfile() function returns NULL.

SEE ALSO
free(3), kinfo_getvmmap(3), malloc(3), sysctl(3)

HISTORY
The kinfo_getfile() function first appeared in FreeBSD 7.0.